/**
 * Copyright (c) 2013 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda3/).
 */
package org.xmloperator.lambda3.exception;

import java.io.PrintStream;

/**
 * Exception raised during term parsing.
 */
public class ParsingException extends RuntimeException {
	private static final long serialVersionUID = -6706674924314948983L;

	private final int stringIndex;
	private String parsedText = null;

	public ParsingException(int stringIndex, String message) {
		super(message);
		this.stringIndex = stringIndex;
	}

	public void setParsedText(String parsedText) {
		this.parsedText = parsedText;
	}

	public void printTrace(PrintStream trace) {
		if (this.parsedText != null) {
			trace.println("Parsing error");
			trace.println(this.parsedText);
			for (int k = 0; k < this.stringIndex; k++)
				trace.print('-');
			trace.println("^ " + this.getMessage());
		} else
			trace.println(this.getMessage() + " at position "
					+ this.stringIndex);
	}
}
