/**
 * Copyright (c) 2013 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda3/).
 */
package org.xmloperator.lambda3.model;

import org.xmloperator.lambda3.exception.term.StillReferencedTermException;

/**
 * Tool for recycling terms.
 */
public interface TermRecycler {

	/**
	 * Breaks the given root Term and its unshared sub-terms. The root Term and
	 * its unshared sub-terms are recycled. Breaking a Term is possible only if
	 * it is no more referenced. A Variable is not broken as Term but as
	 * Abstraction bound Variable.
	 * 
	 * @param rootTerm
	 *            a root Term.
	 * @throws StillReferencedTermException
	 *             if the given root Term is still referenced.
	 */
	public void breakTermDeeply(Term rootTerm);
}
