/**
 * Copyright (c) 2013 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda3/).
 */
package org.xmloperator.lambda3.model.type;

/**
 * TermType created for a set of constants, such as native integers.
 */
public interface ConstantTermType extends TermType {
	/**
	 * For native integers.
	 */
	static final char CHAR_INTEGER_TYPE_NAME = 'Z';
	static final char CHAR_FLOAT_TYPE_NAME = 'R';

	/**
	 * Returns the char (not zero) associated to this ConstantTermType.
	 * 
	 * @return the char (not zero) associated to this ConstantTermType.
	 */
	public char getConstantTypeChar();
}
